typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef unsigned long       DWORD;

#ifndef FALSE
#define FALSE   0
#endif

#ifndef TRUE
#define TRUE    !FALSE
#endif

typedef int BOOL;



typedef struct {
    unsigned port;
    unsigned char index;
    unsigned char value;
} _Register;


typedef struct {
    int HTotal;
    int HDisp;
    int HBStart;
    int HSStart;
    int HSEnd;
    int HBEnd;
    int VTotal;
    int VDisp;
    int VBStart;
    int VSStart;
    int VSEnd;
    int VBEnd;

    int width;
    int height;
    int hpolarity;
    int vpolarity;
    int doublescan;
    int interlace;
    int interlaceratio;

    long dotclockHz;
    long horzHz;
    long vert001Hz;
} CRTCPARAM;



typedef struct {
    DWORD denumerator;
    DWORD postscalar;
    DWORD divider;
    DWORD numerator;
    DWORD seqdivider;
    double dotclock;
    int x;
    int y;
    double horzKHz;
    double vertHz;
    int interlace;
    int hpolarity;
    int vpolarity;
    DWORD hskew;
} MiscParam;

typedef struct {
    int forx;
    int fory;
    CRTCPARAM *cp;
    DWORD group;
    DWORD orientation;
} SCRLIST;



void GetCrtcParam(CRTCPARAM *cp, MiscParam *mc, _Register *rg, int registerlen);
void SetGenericVGARegister(CRTCPARAM *cp);
long CalcDotclock(long Vert001Hz, int HTotal, int VTotal, int interlace);
long CalcVert001Hz(long dotclockHz, int HTotal, int VTotal, int interlace);
long CalcHorizontalHz(long dotclockHz, int HTotal);


void DispCrtcParam(CRTCPARAM *cp);

DWORD BitMov(DWORD dstdata, int dstbitpos, DWORD srcdata, int srcbitpos);

void _out(int edx, BYTE al);
BYTE _in(int edx);

void _outb(int edx, BYTE al);
BYTE _inb(int edx);
void _outw(int edx, WORD ax);
WORD _inw(int edx);
void _outl(int edx, DWORD eax);
DWORD _inl(int edx);



BYTE GetSeqReg(BYTE);
void SetSeqReg(BYTE, BYTE);
BYTE GetCrtcReg(BYTE);
void SetCrtcReg(BYTE, BYTE);
BYTE GetAtrbData(BYTE);
void SetAtrbData(BYTE, BYTE);
void SetGfxcReg(BYTE __idx, BYTE data);
BYTE GetGfxcReg(BYTE __idx);

void SetHVPolarity(int HPolar, int VPolar);
void SetTextHeight(int height);

void DisableGenerateSignal(void);
void EnableGenerateSignal(void);

int GetMode15KHz(CRTCPARAM *cp);

void SetCRTCPARAM(CRTCPARAM* cp);
void GetCRTCPARAM(CRTCPARAM* cp, int num);

void logerror(char* txt, ...);

int  GetSeqDivider(void);
void SetSeqDivider(int d0);
