//#define MAME

#ifdef MAME

  #include "mamalleg.h"
  #include "driver.h"

#else

  #include <allegro.h>

  static void logerror(char* txt, ...)
  {


  }

#endif





#include <pc.h>
#include <conio.h>
#include <sys/farptr.h>
#include <go32.h>
#include <time.h>
#include <math.h>
#include <dpmi.h>
#include "savage15.h"
#include "mode15k.h"





static void SetSavageExtRegister(CRTCPARAM *cp);
static int	GetSavageBytePerLine(void);
static void SetSavageBytePerLine(int d0);
static void SetSavageInterlace(int flag, CRTCPARAM* cp);
static void SetSavageVClock(BYTE Num, BYTE DeN, BYTE PS, BYTE SeqDiv);


static long GetSavageVclkParam(long vclk, int *Num, int *DeN, int *PS, int *SeqDiv);


static void SetDoubleScan(int flag);
static void SelectPLL(void);



int detectSavage(void)
{
	__dpmi_regs 	r;

	r.d.eax = 0x0000b101;						// PCI BIOS - INSTALLATION CHECK
	r.d.edi = 0x00000000;
	__dpmi_int(0x1a, &r);
	if( r.d.edx != 0x20494350 ){				// ' ICP'
		logerror("15.75KHz: PCI BIOS not Installed.\n");
		return 0;
	}

	while(1){
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00008A20;						// device ID
		r.d.edx = 0x00005333;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			logerror("Savage3D found\n");
			break;
		}
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00008A21;						// device ID
		r.d.edx = 0x00005333;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			logerror("Savage3DM found\n");
			break;
		}
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00008A22;						// device ID
		r.d.edx = 0x00005333;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			logerror("Savage4 found\n");
			break;
		}

		logerror("Savage not found\n");
		return 0;
	}

#ifdef MAME
	DisableStretch();
#endif

	return 1;
}




void resetSavage_15KHz(void)
{
}



int setSavage(void)
{
	CRTCPARAM cp;
	int Num;
	int DeN;
	int PS;
	int SeqDiv;

	if(GetMode15KHz(&cp) == 0) return 0;
	cp.dotclockHz = GetSavageVclkParam(cp.dotclockHz, &Num, &DeN, &PS, &SeqDiv);
	cp.vert001Hz  = CalcVert001Hz(cp.dotclockHz, cp.HTotal,
								  cp.VTotal, cp.interlace);
	cp.horzHz	  = CalcHorizontalHz(cp.dotclockHz, cp.HTotal);

	cp.HBStart = cp.HSStart;
	cp.HBEnd   = cp.HTotal - 16;
	cp.VBStart = cp.VDisp;
	cp.VBEnd   = cp.VTotal - 2;

	DispCrtcParam(&cp);

	DisableGenerateSignal();
	SetSeqReg(0x08, 0x06);							// unlock ext seq regs
	SetCrtcReg(0x35, GetCrtcReg(0x35) & 0x0F);		// unlock H V P
	SetCrtcReg(0x38, 0x48); 						//
	SetCrtcReg(0x39, 0xA5); 						//
	SetGenericVGARegister(&cp);
	SetSavageExtRegister(&cp);

	SetSavageVClock(Num, DeN, PS, SeqDiv);
	EnableGenerateSignal();

	return 1;
}

int setSavage_15KHz(int vdouble, int width, int height)
{
	return setSavage();
}





static void SelectPLL(void)
{
	BYTE d0;

	d0 = _in(0x3CC);
	d0 = d0 | 0x0C;
	_out(0x3C2, d0);
}





void SetSavageExtRegister(CRTCPARAM *cp)
{
	int d0;
	int d1;
	int HTotal;
	int HSStart;
	int HSEnd;

	HTotal	= cp->HTotal  >> 3;
	HSStart = cp->HSStart >> 3;
	HSEnd	= cp->HSEnd   >> 3;

	d1 = ((HTotal - 5) + HSStart) / 2;
	if((d1 - HSStart) < 4){
	  if ((HSStart + 4) <= (HTotal - 5))
		 d1 = HSStart + 4;
	  else
		 d1 = HTotal - 5 + 1;
	}

	d0 = 0;
	d0 = BitMov(d0, 0, (cp->HTotal	>> 3) - 5, 8);
	d0 = BitMov(d0, 1, (cp->HDisp	>> 3) - 1, 8);
	d0 = BitMov(d0, 2, (cp->HBStart >> 3)	 , 8);
	d0 = BitMov(d0, 4, (cp->HSStart >> 3)	 , 8);
	if ((cp->HBEnd >> 3) - (cp->HBStart >> 3) > 64)
		d0 = BitMov(d0, 3, 1, 0);
	if ((cp->HSEnd >> 3) - (cp->HSStart >> 3) > 32)
		d0 = BitMov(d0, 5, 1, 0);
	d0 = BitMov(d0, 6, d1, 8);

	SetCrtcReg(0x5D, d0);						// ext horz reg
	SetCrtcReg(0x3B, d1);						// data transfer exec pos
	logerror("data transfer exec pos %d\n", d1 << 3);

	d0 = 0;
	d0 = BitMov(d0, 0, cp->VTotal  - 2, 10);
	d0 = BitMov(d0, 1, cp->VDisp   - 1, 10);
	d0 = BitMov(d0, 2, cp->VBStart, 	10);
	d0 = BitMov(d0, 4, cp->VSStart, 	10);
	d0 = BitMov(d0, 6, 1, 0);					// line compare
	SetCrtcReg(0x5E, d0);						// ext vert reg

	SetDoubleScan(cp->doublescan);
	SetSavageInterlace(cp->interlace, cp);
	SetHVPolarity(cp->hpolarity, cp->vpolarity);
}






static int GetSavageBytePerLine(void)
{
	DWORD d0;

	d0	= (DWORD)GetCrtcReg(0x19);
	d0 |= (DWORD)((GetCrtcReg(0x51) << 4) & 0x0300);
	d0 = d0 << 3;
	return d0;
}

static void SetSavageBytePerLine(int d0)
{
	BYTE d1;

	d0 = d0 >> 3;
	d1 = (BYTE)(d0 & 0xFF);
	SetCrtcReg(0x19, d1);
	d1 = GetCrtcReg(0x51) & ~0x30;
	d1 = d1 | ((d0 >> 4) & 0x30);
	SetCrtcReg(0x51, d1);
}


static void SetDoubleScan(int flag)
{
	if(flag == 0){
		SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 0, 0));
	}else{
		SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 1, 0));
	}
}


static void SetSavageInterlace(int flag, CRTCPARAM *cp)
{
	int d1;

	if(flag == 0){
		d1 = GetCrtcReg(0x42) & ~0x20;
		SetCrtcReg(0x42, d1);
	}else{
		d1 = ((cp->HTotal >> 3) - 5) / 2;
		d1 = (d1 * cp->interlaceratio) / 100;
		SetCrtcReg(0x3C, d1);						// interlace offset
		d1 = GetCrtcReg(0x42) | 0x20;
		SetCrtcReg(0x42, d1);
	}
}



static long GetSavageVclkParam(long vclk, int *Num, int *DeN, int *PS, int *SeqDiv)
{
	double desfreq;
	double temp;
	double tempdt;
	double dt;
	int d0;
	int d1;

	if(vclk > 175000000) vclk = 175000000;
	*SeqDiv = 1;
	*PS 	= 1;
	if( 	 vclk >= 150000000){
		*PS  = 1;
	}else if(vclk >=  75000000){
		*PS  = 2;
	}else if(vclk >=  37500000){
		*PS  = 4;
	}else if(vclk >=  13500000){
		*PS  = 8;
	}else{
//		  *SeqDiv = 2;
//		  *PS  = 8;
		*PS  = 16;
	}

	desfreq = vclk * (*PS) * (*SeqDiv);
	dt = 250000000.0;
	*Num = 0;
	*DeN = 0;
	d0 = 2;
	while(d0 < 255){
		d1 = 2;
		while(d1 < 127){
			temp   = 14318000 * (double)d0 / d1;
			tempdt = desfreq - temp;
			if(tempdt < 0) tempdt *= -1;
			if(tempdt < dt){
				*Num = d0;
				*DeN = d1;
				dt = tempdt;
			}
			d1 += 1;
		}
		d0 += 1;
	}
	logerror("Num %3d, DeN %3d, PS %1d, SeqDiv %1d\n", *Num, *DeN, *PS, *SeqDiv);
	logerror("14.318 * (Num/DeN) : %lf\n", 14.318 *((*Num)/(*DeN)));
	logerror("14.318 * (Num/DeN)/(PS*SeqDiv) : %lf\n", 14.318 * ((double)(*Num)/(*DeN))
													/ ((*PS) * (*SeqDiv)));
	vclk = 14318000 * ((double)(*Num)/(*DeN) / ((*PS) * (*SeqDiv)));
	logerror("vclk : %lf\n", (double)vclk / 1000000.0);

	return vclk;
}



static void SetSavageVClock(BYTE Num, BYTE DeN, BYTE PS, BYTE SeqDiv)
{
	DWORD _PS;
	BYTE d0;
	BYTE SR12, SR13, SR29;

	SelectPLL();

	Num -= 2;
	DeN -= 2;
	_PS = 0;
	while(1){
		PS = PS >> 1;
		if(PS == 0) break;
		_PS += 1;
	}
	SR12 = (DeN & 0x3F) | (_PS << 6);
	SR13 = Num & 0xFF;
	SR29 = (_PS & 0x04) | (Num & 0x100) >> 5 | ((DeN & 0x40) >> 2);

	SetSeqReg(0x12, SR12);
	SetSeqReg(0x13, SR13);
	SetSeqReg(0x29, SR29);

	d0 = GetSeqReg(0x15) & ~0x21;
	d0 = d0 & ~(1 << 4);
	if(SeqDiv == 2)
		d0 |= (1 << 4);
	SetSeqReg(0x15, d0 | 0x03);
	SetSeqReg(0x15, d0 | 0x23);
	SetSeqReg(0x15, d0 | 0x03);
}
