
; ******************************************
; linebuff format
;
;	QWORD	y[i-1][0]
;	QWORD	y[i-1][1]
;	QWORD	y[i  ][0]
;	QWORD	y[i  ][1]
;	QWORD	y[i+1][0]
;	QWORD	y[i+1][1]
;	QWORD	y[i+2][0]
;	QWORD	y[i+2][1]
;	QWORD	y[i-1][2]
;	QWORD	y[i-1][3]
;	QWORD	y[i  ][2]
;	QWORD	y[i  ][3]
;	QWORD	y[i+1][2]
;	QWORD	y[i+1][3]
;	QWORD	y[i+2][2]
;	QWORD	y[i+2][3]
;				.
;				.
;				.
;				.
; ******************************************



[BITS 32]

extern _palette_16bit_lookup			; for 16 bit palettized mode


[SECTION .data]

TABLEBITS	equ 7
TABLESIZE	equ (1 << TABLEBITS)


vesa_color_mask0	equ 	(0 * 8)
vesa_color_shift0	equ 	(1 * 8)
vesa_color_mask1	equ 	(2 * 8)
vesa_color_shift1	equ 	(3 * 8)
vesa_color_mask2	equ 	(4 * 8)
vesa_color_shift2	equ 	(5 * 8)
vesa_color_depth	equ 	(6 * 8)
neg_byte			equ 	(7 * 8)
ip4point_table_top	equ 	(8 * 8)




GLOBAL _ip4point_table1
GLOBAL _ip4point_table2


align 4
_ip4point_table1:
%rep (((TABLESIZE + 1) * 2) * 2)
	db 0
%endrep

align 4
_ip4point_table2:
%rep (((TABLESIZE + 1) * 2) * 2)
	db 0
%endrep


align 4
_low_bit_mask:	dd	0x07070707
				dd	0x07070707
_neg_byte:		dd	0x80808080
				dd	0x80808080


align 4
;
; due to alignment...
;
_ip4point_param_base_address:
				dd	0				; pad dword
_vesa_color_conv_label:
%rep (8 * 8)						; qword * 8
	db 0
%endrep

_ip4point_table_start:
%rep (8 * TABLESIZE * 4)			; qword * TABLESIZE * 4
	db 0
%endrep

p_ip4point_table_label:
				dd	0
				dd	0
				dd	0
				dd	0
				dd	0
				dd	0
				dd	0
				dd	0


_vesa_color_conv_table_address:
				dd	0
p_ip4point_table_address:
				dd	0

[SECTION .text]

; ******************************************
; function prototype
; UINT32* ip4point_init(void);
;
; ******************************************

GLOBAL _ip4point_init

_ip4point_init:
	mov 	eax, p_ip4point_table_label
	and 	eax, ~0x00000007
	mov 	[p_ip4point_table_address], eax
	mov 	eax, _vesa_color_conv_label
	and 	eax, ~0x00000007
	mov 	[_vesa_color_conv_table_address], eax
	ret



; ******************************************
; function prototype
; void upsampling_using_4lines(
;			int width,
;			int linebuff_top,
;			void* src,
;			void* dst,
;			void* mul_table_adrs,
;			short dstseg);
; ******************************************

; list of parameters
width			equ 8
linebuff_top	equ 12
src 			equ 16
dst 			equ 20
mul_table_adrs	equ 24
dstseg			equ 28


GLOBAL _upsampling_using_4lines

_upsampling_using_4lines:
	push	ebp
	mov 	ebp, esp
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi
;	 push	 fs

	mov 	ebx, [ebp + mul_table_adrs]
	mov 	esi, [ebp + width]
	shr 	esi, 1					; loop counter
	mov 	edx, [ebp + linebuff_top]
	shl 	edx, 4					; edx = 0x00 or 0x10 or 0x20 or 0x30
	mov 	ecx, [ebp + src]
	mov 	edi, [ebp + dst]
	mov 	fs, [ebp + dstseg]


align 16
.loop1:
									;0 ; edx = [ebp + linebuff_top]
									;0 ; ebx = [p_ip4point_table_address]
	pxor	mm6, mm6				;0
	pxor	mm7, mm7				;0

	movq	mm4, [ebx]				;1 ;							;mm4 start
	mov 	eax, ecx				;1
	add 	ecx, edx				;1 ; ecx = src address
	movq	mm0, [ecx]				;1 ; mm0 = 00r0g0b0   load b1mm0
	movq	mm1, [ecx + 8]			;1 ; mm1 = 00r0g0b0   load b1mm1
	pmulhw	mm0, mm4				;1 ; i.d8 * i.d14 = i.d22
	pmulhw	mm1, mm4				;1 ; i.d8 * i.d14 = i.d22		;mm4 end
	paddsw	mm6, mm0				;1 ; i.d6				   b1mm0 done
	paddsw	mm7, mm1				;1 ; i.d6				   b1mm1 done
	add 	edx, BYTE 0x10			;1
	and 	edx, BYTE 0x30			;1 ;   edx ok

	movq	mm5, [ebx + 8]			;2								;mm5 start
	mov 	ecx, eax				;2
	add 	eax, edx				;2 ; eax = src address
	movq	mm2, [eax]				;2 ; mm2 = 00r0g0b0   load b2mm2
	movq	mm3, [eax + 8]			;2 ; mm3 = 00r0g0b0   load b2mm3
	pmulhw	mm2, mm5				;2 ; i.d8 * i.d14 = i.d22
	pmulhw	mm3, mm5				;2 ; i.d8 * i.d14 = i.d22		;mm5 end
	paddsw	mm6, mm2				;2 ; i.d6				   b2mm2 done
	paddsw	mm7, mm3				;2 ; i.d6				   b2mm3 done
	add 	edx, BYTE 0x10			;2
	and 	edx, BYTE 0x30			;2 ;   edx ok

	movq	mm4, [ebx + 16] 		;3								;mm4 start
	mov 	eax, ecx				;3
	add 	ecx, edx				;3 ; ecx = src address
	movq	mm0, [ecx]				;3 ; mm0 = 00r0g0b0   load b3mm0
	movq	mm1, [ecx + 8]			;3 ; mm1 = 00r0g0b0   load b3mm1
	pmulhw	mm0, mm4				;3 ; i.d8 * i.d14 = i.d22
	pmulhw	mm1, mm4				;3 ; i.d8 * i.d14 = i.d22		;mm4 end
	paddsw	mm6, mm0				;3 ; i.d6				   b3mm0 done
	paddsw	mm7, mm1				;3 ; i.d6				   b3mm1 done
	add 	edx, BYTE 0x10			;3
	and 	edx, BYTE 0x30			;3 ;  edx ok

	movq	mm5, [ebx + 24] 		;4								;mm5 start
	mov 	ecx, eax				;4
	add 	eax, edx				;4 ; eax = src address
	movq	mm2, [eax]				;4 ; mm2 = 00r0g0b0   load b4mm2
	movq	mm3, [eax + 8]			;4 ; mm3 = 00r0g0b0   load b4mm3
	pmulhw	mm2, mm5				;4 ; i.d8 * i.d14 = i.d22
	pmulhw	mm3, mm5				;4 ; i.d8 * i.d14 = i.d22		;mm5 end
	paddsw	mm6, mm2				;4 ; i.d6				   b4mm2 done
	paddsw	mm7, mm3				;4 ; i.d6				   b4mm3 done
	add 	edx, BYTE 0x10			;4
	and 	edx, BYTE 0x30			;4	 edx ok

	mov 	eax, [_vesa_color_conv_table_address]			; conv
	movq	mm0, [eax + vesa_color_mask0]					; conv
	movq	mm4, [eax + vesa_color_shift1]					; conv
	movq	mm5, [eax + vesa_color_shift0]					; conv
	movq	mm1, [eax + vesa_color_mask1]					; conv

	psraw	mm6, 6					; i.d6 to i
	psraw	mm7, 6					; i.d6 to i
	packsswb	mm6, mm7			; mm6 = 0rgb0rgb (index1:index0)
	paddb	mm6, [eax + neg_byte]	; signed (-128 to 127) to unsigned (0 to 255)

	; convert 32bpp to 16(15)bpp
	pand	mm0, mm6   ;vesa_color_mask0	   ; bit mask
	pand	mm1, mm6   ;vesa_color_mask1	   ; bit mask
	psrlq	mm0, mm5   ;vesa_color_shift0	   ; bit shift
	pand	mm6, [eax + vesa_color_mask2]	   ; bit mask
	psrlq	mm1, mm4   ;vesa_color_shift1	   ; bit shift
	psrlq	mm6, [eax + vesa_color_shift2]	   ; bit shift
	por 	mm0, mm1
	por 	mm0, mm6

	movq	mm2, mm0
	psrlq	mm0, 16
	add 	edi, 4
	por 	mm2, mm0
	movd	[fs:edi - 4], mm2
	add 	ecx, 64 										; src address += 64
	dec 	esi
	jnz 	NEAR .loop1

	emms
;	 pop	 fs
	pop 	edi
	pop 	esi
	pop 	edx
	pop 	ecx
	pop 	ebx
	leave
	ret



; ******************************************
; function prototype
; void copy_src_to_linebuff_palettized(
;			int width,
;			void* src,
;			void* dst);
; ******************************************

; list of parameters
_2width 		  equ 8
_2src			  equ 12
_2dst			  equ 16


GLOBAL _copy_src_to_linebuff_palettized

_copy_src_to_linebuff_palettized:
	push	ebp
	mov 	ebp, esp
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi

	mov 	edx, [_palette_16bit_lookup]
	mov 	ecx, [ebp + _2src]
	mov 	edi, [ebp + _2dst]
	mov 	esi, [ebp + _2width]
	shr 	esi, 1
	movq	mm7, [_low_bit_mask]
	movq	mm6, [_neg_byte]
	mov 	eax, [_vesa_color_conv_table_address]
	xor 	ebx, ebx
	movq	mm5, [eax + vesa_color_mask0]
	xor 	eax, eax
	sub 	edi, 64

align 16
.loop:
	mov 	bx, [ecx + 2]
	mov 	ax, [ecx + 0]
	add 	ecx, 4
	movd	mm1, [edx + ebx*4]
	movd	mm0, [edx + eax*4]
	psllq	mm1, 32
	por 	mm0, mm1				; mm0 = 0000dddd:0000dddd (index1:index0)

	; convert 16(15)bpp to 32bpp
	mov 	eax, [_vesa_color_conv_table_address]
	movq	mm1, mm0
	movq	mm2, mm0
	psllq	mm0, [eax + vesa_color_shift0]	   ; bit shift
	psllq	mm1, [eax + vesa_color_shift1]	   ; bit shift
	psllq	mm2, [eax + vesa_color_shift2]	   ; bit shift
	pand	mm0, mm5   ;vesa_color_mask0	   ; bit mask
	pand	mm1, [eax + vesa_color_mask1]	   ; bit mask
	por 	mm0, mm7				; mm0 = mm0 | 0x0707070707070707
	pand	mm2, [eax + vesa_color_mask2]	   ; bit mask
	xor 	eax, eax
	por 	mm0, mm1
	pxor	mm3, mm3
	por 	mm0, mm2				; mm0 = 00rrggbb:00rrggbb (index1:index0)
	pxor	mm4, mm4
	psubb	mm0, mm6				; unsigned (0 to 255) to signed (-128 to 127)

	add 	edi, 64
	punpcklbw	mm3, mm0			; mm1 = x0r0g0b0
	punpckhbw	mm4, mm0			; mm2 = x0r0g0b0

	movq	[edi], mm3
	movq	[edi+8], mm4

	dec 	esi
	jnz 	.loop

	emms
	pop 	edi
	pop 	esi
	pop 	edx
	pop 	ecx
	pop 	ebx
	leave
	ret



; ******************************************
; function prototype
; void copy_src_to_linebuff_palettized_32bpp(
;			int width,
;			void* src,
;			void* dst);
; ******************************************

; list of parameters
_4width 		  equ 8
_4src			  equ 12
_4dst			  equ 16


GLOBAL _copy_src_to_linebuff_palettized_32bpp

_copy_src_to_linebuff_palettized_32bpp:
	push	ebp
	mov 	ebp, esp
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi

	movq	mm6, [_neg_byte]
	xor 	eax, eax
	xor 	ebx, ebx
	mov 	edx, [_palette_16bit_lookup]
	mov 	ecx, [ebp + _4src]
	mov 	edi, [ebp + _4dst]
	mov 	esi, [ebp + _4width]
	shr 	esi, 1
	sub 	edi, 64

align 16
.loop:
	mov 	bx, [ecx + 2]
	mov 	ax, [ecx]
	add 	ecx, 4
	movd	mm1, [edx + ebx*4]
	movd	mm0, [edx + eax*4]
	psllq	mm1, 32
	pxor	mm4, mm4
	por 	mm0, mm1				; mm0 = 00rrggbb:00rrggbb (index1:index0) 32bpp
	pxor	mm5, mm5
	psubb	mm0, mm6				; unsigned (0 to 255) to signed (-128 to 127)

	add 	edi, 64
	punpcklbw	mm4, mm0			; mm1 = x0r0g0b0
	punpckhbw	mm5, mm0			; mm2 = x0r0g0b0

	movq	[edi], mm4
	movq	[edi+8], mm5

	dec 	esi
	jnz 	.loop

	emms
	pop 	edi
	pop 	esi
	pop 	edx
	pop 	ecx
	pop 	ebx
	leave
	ret





; ******************************************
; function prototype
; void copy_src_to_linebuff(
;			int width,
;			void* src,
;			void* dst);
; ******************************************

; list of parameters
_3width 		  equ 8
_3src			  equ 12
_3dst			  equ 16


GLOBAL _copy_src_to_linebuff

_copy_src_to_linebuff:
	push	ebp
	mov 	ebp, esp
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi

	mov 	ecx, [ebp + _3src]
	mov 	edi, [ebp + _3dst]
	mov 	esi, [ebp + _3width]
	shr 	esi, 1
	movq	mm7, [_low_bit_mask]
	movq	mm6, [_neg_byte]
	mov 	eax, [_vesa_color_conv_table_address]
	xor 	ebx, ebx
	movq	mm5, [eax + vesa_color_mask0]
	sub 	edi, 64

align 16
.loop:
	mov 	bx, [ecx + 2]
	movd	mm1, ebx
	psllq	mm1, 32
	mov 	bx, [ecx + 0]
	movd	mm0, ebx
	add 	ecx, 4
	por 	mm0, mm1				; mm0 = 0000dddd:0000dddd (index1:index0)

	; convert 16(15)bpp to 32bpp
	movq	mm1, mm0
	movq	mm2, mm0
	psllq	mm0, [eax + vesa_color_shift0]	   ; bit shift
	psllq	mm1, [eax + vesa_color_shift1]	   ; bit shift
	psllq	mm2, [eax + vesa_color_shift2]	   ; bit shift
	pand	mm0, mm5   ;vesa_color_mask0	   ; bit mask
	pand	mm1, [eax + vesa_color_mask1]	   ; bit mask
	por 	mm0, mm7				; mm0 = mm0 | 0x0707070707070707
	pand	mm2, [eax + vesa_color_mask2]	   ; bit mask
	por 	mm0, mm1
	pxor	mm3, mm3
	por 	mm0, mm2				; mm0 = 00rrggbb:00rrggbb (index1:index0)
	pxor	mm4, mm4
	psubb	mm0, mm6				; unsigned (0 to 255) to signed (-128 to 127)

	add 	edi, 64
	punpcklbw	mm3, mm0			; mm1 = x0r0g0b0
	punpckhbw	mm4, mm0			; mm2 = x0r0g0b0

	movq	[edi], mm3
	movq	[edi+8], mm4
	dec 	esi
	jnz 	.loop


	emms
	pop 	edi
	pop 	esi
	pop 	edx
	pop 	ecx
	pop 	ebx
	leave
	ret
