#define MAME

#ifdef MAME

  #include "mamalleg.h"
  #include "driver.h"

#else

  #include <allegro.h>

  static void logerror(char* txt, ...)
  {


  }

#endif


//#define BladeDEBUG


#include <pc.h>
#include <conio.h>
#include <sys/farptr.h>
#include <go32.h>
#include <time.h>
#include <math.h>
#include <dpmi.h>
#include "blade15.h"
#include "mode15k.h"



/* 3C4 */
#define OldNewModeControl 0x0B

#define NewMode2 0x0D
#define NewMode1 0x0E
#define Protection 0x11
#define MCLKLow 0x16
#define MCLKHigh 0x17
#define ClockLow 0x18
#define ClockHigh 0x19

/* 3x4 */

#define InterlacedVsyncAdjust 0x19
#define HorizontalParamOverflow 0x2B

#define Offset 0x13
#define CRTCModuleTest 0x1E
#define CRTHiOrd 0x27
#define AddColReg 0x29

/* 3CE */

#define MiscInternalControlReg 0x2F



static DWORD REFFREQ  =  14318180;
static DWORD VCO_MAX  = 230000000;
static DWORD VCO_MIN  = 14318180 * 3.5;
static DWORD VCLK_MAX = 230000000;



static int DetectBlade3D(void);
static void NewMode(void);
static void UnprotectRegisters(void);

static double GetCurrentDotClock(void);
static double GetCurrentMClock(void);
static double GetPixelClockDivider(void);
static void SetPixelClockDivider(int d0);

static DWORD GetHTotal(void);
static DWORD GetVTotal(void);

static void SetBladeExtRegister(CRTCPARAM *cp);
static DWORD GetBladeBytesPerLine(void);
static void SetBladeBytesPerLine(DWORD d0);
static void SetBladeInterlace(int flag, CRTCPARAM* cp);

static void SetBladeVClock(int Num, int DeN, int PS, int PCDiv);
static long GetBladeVclkParam(long vclk, int *Num, int *DeN, int *PS, int *PCDiv);

static void SetDoubleScan(int flag);

DWORD GetBladeScreenStartAddress(void);
void SetBladeScreenStartAddress(DWORD d0);
static void SetHSyncSkewInMisc(int flag);
static int GetDoubleLogicalLineWidth(void);
static void SetDoubleLogicalLineWidth(int flag);




int detectBlade(void)
{
	__dpmi_regs 	r;

	r.d.eax = 0x0000b101;						// PCI BIOS - INSTALLATION CHECK
	r.d.edi = 0x00000000;
	__dpmi_int(0x1a, &r);
	if( r.d.edx != 0x20494350 ){				// ' ICP'
		logerror("15.75KHz: PCI BIOS not Installed.\n");
		return 0;
	}

	while(1){
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00009880;						// device ID
		r.d.edx = 0x00001023;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			if(DetectBlade3D() != 0){
				REFFREQ  =	14318180;
				VCO_MAX  = 230000000;
				VCO_MIN  = (DWORD)(REFFREQ * 3.5);		// It seems that Blade3D still has this limitation
				VCLK_MAX = 230000000;
				logerror("Trident Blade 3D found\n");
				break;
			}
		}
		logerror("no Trident Blade 3D found\n");
		return 0;
	}

#ifdef MAME
	DisableStretch();
#endif

	return 1;
}




void resetBlade_15KHz(void)
{
}



int setBlade(void)
{
	CRTCPARAM cp;
	int Num;
	int DeN;
	int PS;
	int PCDiv;

	NewMode();
	UnprotectRegisters();

	if(GetMode15KHz(&cp) == 0) return 0;

	cp.dotclockHz = GetBladeVclkParam(cp.dotclockHz, &Num, &DeN, &PS, &PCDiv);
	cp.vert001Hz  = CalcVert001Hz(cp.dotclockHz, cp.HTotal,
								  cp.VTotal, cp.interlace);
	cp.horzHz	  = CalcHorizontalHz(cp.dotclockHz, cp.HTotal);

	if(Num == 0){
		logerror("Unable to set programmable clock.\n");
		return 0;
	}

	cp.HBStart = cp.HDisp;
	cp.HBEnd   = cp.HSEnd;
	cp.VBStart = cp.VDisp;
	cp.VBEnd   = cp.VSEnd;

	DispCrtcParam(&cp);

	DisableGenerateSignal();
	SetGenericVGARegister(&cp);
	SetBladeExtRegister(&cp);
	SetHSyncSkewInMisc(0);
	SetBladeVClock(Num, DeN, PS, PCDiv);

	EnableGenerateSignal();
#ifdef MAME
	RegCRTCPARAM(&cp);
#endif


#ifndef BladeDEBUG
if(0){
#endif

	logerror("%d byte per line\n", (int)GetBladeBytesPerLine());
	logerror("start address %d\n", (int)GetBladeScreenStartAddress());
	logerror("double width %d\n", GetDoubleLogicalLineWidth());

	logerror("MCLK %lf\n", GetCurrentMClock() );
	logerror("dotclock %lf\n", GetCurrentDotClock()/1000000 );
	logerror("htotal   %ld\n", GetHTotal());
	logerror("vtotal   %ld\n", GetVTotal());

	logerror("(SeqDiv	%d)\n", (int)GetSeqDivider());
	logerror("(PD		%lf)\n", GetPixelClockDivider());

	logerror("refresh rate %.2lf\n", GetCurrentDotClock()
									  / (double)(GetHTotal() * GetVTotal()));
#ifndef BladeDEBUG
}
#endif
	return 1;
}



int setBlade_15KHz(int vdouble, int width, int height)
{
	return setBlade();
}


#ifdef MAME

void centerBlade_15KHz(int dx, int dy)
{
	CRTCPARAM cp;

	GetCRTCPARAM(&cp);
	Centering(&cp, dx*8, dy);

	cp.HBStart = cp.HDisp;
	cp.HBEnd   = cp.HSEnd;
	cp.VBStart = cp.VDisp;
	cp.VBEnd   = cp.VSEnd;

	RegCRTCPARAM(&cp);
	SetGenericVGARegister(&cp);
	SetBladeExtRegister(&cp);

}

#endif








void SetBladeExtRegister(CRTCPARAM *cp)
{
	BYTE d0;
	int d1;
	int interlaceoffset;

	if(cp->interlaceadjust == 0){
		d1 = (cp->HSStart/8) + (cp->HSEnd/8) - ((cp->HTotal/8) - 5);
		if(d1 < 0) d1 = 0;
		d1 = d1 / 2;
		interlaceoffset = d1;
	}else{
		interlaceoffset = cp->interlaceadjust / 8;
	}
	SetCrtcReg(InterlacedVsyncAdjust, (BYTE)(interlaceoffset & 0xFF));

	d0 = GetCrtcReg(HorizontalParamOverflow);
	d0 = BitMov(d0, 0, (cp->HTotal	>> 3) - 5, 9);
	d0 = BitMov(d0, 1, (cp->HDisp	>> 3) - 1, 9);
	d0 = BitMov(d0, 2, interlaceoffset		 , 9);
	d0 = BitMov(d0, 3, (cp->HSStart >> 3)	 , 9);
	d0 = BitMov(d0, 4, (cp->HBStart >> 3)	 , 9);
	SetCrtcReg(HorizontalParamOverflow, d0);

	d0 = GetCrtcReg(CRTHiOrd);
	d0 = BitMov(d0, 3,				1,	0); 	// line compare bit 10
	d0 = BitMov(d0, 4, cp->VDisp  - 1, 10);
	d0 = BitMov(d0, 5, cp->VSStart	 , 10);
	d0 = BitMov(d0, 6, cp->VBStart	 , 10);
	d0 = BitMov(d0, 7, cp->VTotal - 2, 10);
	SetCrtcReg(CRTHiOrd, d0);

	SetDoubleScan(cp->doublescan);
	SetTextHeight(1);
	SetBladeInterlace(cp->interlace, cp);
	SetHVPolarity(cp->hpolarity, cp->vpolarity);
}






static DWORD GetBladeBytesPerLine(void)
{
	DWORD d0;

	d0 = GetCrtcReg(Offset);
	d0 = BitMov(d0, 8, GetCrtcReg(AddColReg), 4);
	d0 = BitMov(d0, 9, GetCrtcReg(AddColReg), 5);
	d0 = d0 << 3;

	return d0;
}

static void SetBladeBytesPerLine(DWORD d0)
{
	BYTE d1;

	d0 = d0 >> 3;
	SetCrtcReg(Offset, (BYTE)(d0 & 0xFF));
	d1 = GetCrtcReg(AddColReg);
	d1 = (BYTE)BitMov(d1, 4, d0, 8);
	d1 = (BYTE)BitMov(d1, 5, d0, 9);
	SetCrtcReg(AddColReg, d1);
}


static void SetDoubleScan(int flag)
{
	if(flag == 0){
		SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 0, 0));
	}else{
		SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 1, 0));
	}
}


static void SetBladeInterlace(int flag, CRTCPARAM *cp)
{
	BYTE status;

	status = GetCrtcReg(CRTCModuleTest) & 0x04;
	if(flag == 0){
		if(status != 0){
			SetDoubleLogicalLineWidth(0);
			SetCrtcReg(CRTCModuleTest, GetCrtcReg(CRTCModuleTest) & ~0x04);
		}
	}else{
		if(status == 0){
			SetDoubleLogicalLineWidth(1);
			SetCrtcReg(CRTCModuleTest, GetCrtcReg(CRTCModuleTest) | 0x04);
		}
	}
}


static long GetBladeVclkParam(long vclk, int *Num, int *DeN, int *PS, int *PCDiv)
{
	double desfreq;
	double temp;
	double tempdt;
	double dt;
	int n, startn, endn;
	int m, startm, endm;
	int k, startk, endk;
	int pdindex, startpdindex, endpdindex;
	double pd;
	int powerup[4] = { 1, 2, 4, 8 };
	double pdd[4] = {1, 1.5, 2, 4 };
	double pdi[4] = {10, 15, 20, 40 };
	int d0;
	int invalid_n_value[] = {
#if 1
		 0,  1,  2,  3,  4,  5,  6,  7,
		 9, 10, 11, 12, 13, 14, 15,
		18, 19, 20, 21, 22, 23,
		27, 28, 29, 30, 31,
		36, 37, 38, 39,
		45, 46, 47,
		54, 55,
		63,
#endif
		-1
	};


	if(vclk > VCLK_MAX) vclk = VCLK_MAX;


	startn = 8;
	endn   = 247;
	startm = 2;
	endm   = 61;
	startk = 0;
	endk   = 3;
	startpdindex = 0;
	endpdindex	 = 3;

	desfreq = (double)vclk;
	dt = VCLK_MAX;
	*Num = 0;
	*DeN = 0;
	*PS  = 0;
	*PCDiv	= 0;

	for(pdindex = startpdindex; pdindex <= endpdindex; pdindex += 1){
		pd = pdd[pdindex];
		for(k = startk; k <= endk; k += 1){
			for(n = startn; n <= endn; n += 1){
				d0 = 0;
				while(1){
					if(invalid_n_value[d0] == -1) break;
					if(invalid_n_value[d0] == n) break;
					d0 += 1;
				}
				if(invalid_n_value[d0] != -1) continue;
				for(m = startm; m <= endm; m += 1){
					temp = REFFREQ * ((double)(n + 8) / (double)(m + 2));
					if(VCO_MIN <= temp && temp <= VCO_MAX){
						temp = REFFREQ * ((double)(n + 8) / (double)((m + 2) * powerup[k]));
						temp = temp / pd;
						tempdt = desfreq - temp;
						if(tempdt < 0) tempdt *= -1;
						if(tempdt < dt){
							*Num = n;
							*DeN = m;
							*PS  = k;
							*PCDiv	= pdi[pdindex];
							dt = tempdt;
						}
					}
				}
			}
		}
	}

	n = (*Num + 8);
	m = (*DeN + 2);
	k = powerup[*PS];
	pd = (double)(*PCDiv) / 10;

	logerror("Num %3d, DeN %3d, PS %1d, PCDiv %.1lf\n", n, m, k, pd);
	logerror("%.5lf * (Num/DeN) : %lf\n", (double)REFFREQ/1000000,
								(double)REFFREQ/1000000 *(double)n / m);
	logerror("%.5lf * (Num/DeN)/(PS * PCDiv): %lf\n", (double)REFFREQ/1000000,
								(double)REFFREQ/1000000 * (double)n/(m * k * pd));
	vclk = REFFREQ * (double)n/(m * k * pd);
	logerror("vclk : %lf\n", (double)vclk / 1000000.0);

	return vclk;
}


static void UnprotectRegisters(void)
{
	SetSeqReg(Protection, 0x87);
	SetSeqReg(NewMode1, 0xC0 ^ 0x02);
	SetCrtcReg(CRTCModuleTest, GetCrtcReg(CRTCModuleTest) & 0xBF);
}

static void SetBladeVClock(int Num, int DeN, int PS, int PCDiv)
{
	BYTE d0;
	BYTE d1;
	BYTE d2;

	SetPixelClockDivider(PCDiv);
	SetSeqDivider(1);

	/* N is all 8bits */
	d1 = Num;
	/* M is first 6bits, with K last 2bits */
	d2 = (DeN & 0x3F) | (PS << 6);

	SetSeqReg(ClockLow, d1);
	SetSeqReg(ClockHigh, d2);

	d0 = (_inb(0x3CC) & 0xF3) | 0x08;
	_outb(0x3C2, d0);							// use vclk2
}

static void NewMode(void)
{
	BYTE d0;

	d0 = GetSeqReg(OldNewModeControl);
	logerror("Chip Version %2Xh\n", d0);
}

static double GetCurrentDotClock(void)
{
	double d0;
	BYTE d1;
	BYTE d2;
	int k;
	int m;
	int n;
	int powerup[4] = { 1, 2, 4, 8 };


	d1 = GetSeqReg(ClockLow);
	d2 = GetSeqReg(ClockHigh);

	k = (d2 >> 6) & 0x03;
	m = d2 & 0x3F;
	m += 2;
	n = d1;
	n += 8;

	d0 = REFFREQ * ((double)n / (m * powerup[k]));
	d0 = d0 / (GetPixelClockDivider() * GetSeqDivider());
	return d0;
}

static DWORD GetHTotal(void)
{
	DWORD d0;

	d0 = GetCrtcReg(0x00);
	d0 = BitMov(d0, 9, GetCrtcReg(HorizontalParamOverflow), 0);
	d0 += 5;
	d0 *= 8;

	return d0;
}

static DWORD GetVTotal(void)
{
	DWORD d0;
	BYTE d1;

	// Unlock
	SetCrtcReg(0x11, BitMov(GetCrtcReg(0x11), 7, 0, 0));

	d1 = GetCrtcReg(0x03);
	d1 = BitMov(d1, 7, 1, 0);			// compatible read
	SetCrtcReg(0x03, d1);

	d0 = GetCrtcReg(0x06);
	d0 = BitMov(d0, 8, GetCrtcReg(0x07), 0);
	d0 = BitMov(d0, 9, GetCrtcReg(0x07), 5);

	d0 = BitMov(d0, 10, GetCrtcReg(CRTHiOrd), 7);

	d0 += 2;

	return d0;
}


static double GetCurrentMClock(void)
{
	double d0;
	BYTE d1;
	BYTE d2;
	int k;
	int m;
	int n;
	int powerup[4] = { 1, 2, 4, 8 };


	d1 = GetSeqReg(MCLKLow);
	d2 = GetSeqReg(MCLKHigh);

	k = (d2 >> 6) & 0x03;
	m = d2 & 0x3F;
	m += 2;
	n = d1;
	n += 8;

	d0 = (double)(REFFREQ * n) / (m * powerup[k]);

	return d0/1000000;
}

static double GetPixelClockDivider(void)
{
	BYTE d0;
	double pd[4] = { 1, 2, 4, 1.5 };


	d0 = GetSeqReg(NewMode2);
	d0 = d0 >> 1;
	d0 = d0 & 0x03;

	return pd[ (int)d0 ];
}

static void SetPixelClockDivider(int d0)
{
//
//	d0 = PixelClockDiv * 10
//

	BYTE d1;
	BYTE d2;

	switch(d0){
		case 10:		 // div 1
			d1 = 0;
			break;
		case 15:		 // div 1.5
			d1 = 3;
			break;
		case 20:		 // div 2
			d1 = 1;
			break;
		case 40:		 // div 4
			d1 = 2;
			break;
		default:
			d1 = 0;
	}

	d1 = d1 << 1;
	d1 = d1 &  0x06;
	d2 = GetSeqReg(NewMode2);
	d2 = d2 & ~0x06;
	d2 = d2 | d1;
	SetSeqReg(NewMode2, d2);
}

static int DetectBlade3D(void)
{
	BYTE d0;
	int result;

	d0 = GetSeqReg(0x09);
//	  logerror("Seq index 09h %2X\n", d0);
	d0 = d0 & 0xF8;
	if(d0 == 0x38){
		result = 1;
	}else{
		result = 0;
	}

	return result;
}

DWORD GetBladeScreenStartAddress(void)
{
	DWORD d0;

	d0	= (DWORD)GetCrtcReg(0x0D);
	d0 |= (DWORD)GetCrtcReg(0x0C) << 8;
	d0	= BitMov(d0, 16, GetCrtcReg(CRTCModuleTest), 5);
	d0	= BitMov(d0, 17, GetCrtcReg(CRTHiOrd), 0);
	d0	= BitMov(d0, 18, GetCrtcReg(CRTHiOrd), 1);
	d0	= BitMov(d0, 19, GetCrtcReg(CRTHiOrd), 2);
	d0	= d0 << 2;

	return d0;
}

void SetBladeScreenStartAddress(DWORD d0)
{
	DWORD d1;

	d0 = d0 >> 2;
	SetCrtcReg(0x0D, (BYTE)(d0 & 0xFF));
	SetCrtcReg(0x0C, (BYTE)((d0 >> 8)  & 0xFF));

	d1 = GetCrtcReg(CRTCModuleTest);
	d1 = BitMov(d1, 5, d0, 16);
	SetCrtcReg(CRTCModuleTest, (BYTE)d1);

	d1 = GetCrtcReg(CRTHiOrd);
	d1 = BitMov(d1, 0, d0, 17);
	d1 = BitMov(d1, 1, d0, 18);
	d1 = BitMov(d1, 2, d0, 19);
	SetCrtcReg(CRTHiOrd, (BYTE)d1);
}

static void SetHSyncSkewInMisc(int flag)
{
	DWORD d0;

	if(flag == 0){
		flag = 1;
	}else{
		flag = 0;		// no skew
	}
	d0 = GetGfxcReg(MiscInternalControlReg);
	d0 = BitMov(d0, 5, flag, 0);
	SetGfxcReg(MiscInternalControlReg, (BYTE)d0);
}

static int GetDoubleLogicalLineWidth(void)
{
	DWORD d0;

	d0 = GetGfxcReg(MiscInternalControlReg);
	d0 = d0 >> 2;
	d0 = d0 & 0x01;

	return (int)d0;
}

static void SetDoubleLogicalLineWidth(int flag)
{
	DWORD d0;

	if(flag != 0) flag = 1;
	d0 = GetGfxcReg(MiscInternalControlReg);
	d0 = BitMov(d0, 2, flag, 0);
	SetGfxcReg(MiscInternalControlReg, (BYTE)d0);
}
