typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef unsigned long       DWORD;
typedef int BOOL;

#ifndef FALSE
#define FALSE   0
#endif

#ifndef TRUE
#define TRUE    !FALSE
#endif




#define STRICT15KHz     (1 <<  0)
#define STRICTTV15KHz   (1 <<  1)
#define TV15KHz         (1 <<  2)
#define MODE15KHz       (1 <<  3)
#define PAL15KHz        (1 <<  4)
#define SPECIAL15KHz    (1 <<  5)
#define STRICT24KHz     (1 <<  6)
#define MODE24KHz       (1 <<  7)
#define MODE31KHz       (1 <<  8)
#define PCMONITOR       (1 << 16)

#define SCREEN_HORZ     (1 << 0)
#define SCREEN_VERT     (1 << 1)
#define DUAL_MONITOR    (1 << 2)



typedef struct {
    unsigned port;
    unsigned char index;
    unsigned char value;
} _Register;


typedef struct {
    int HTotal;
    int HDisp;
    int HBStart;
    int HSStart;
    int HSEnd;
    int HBEnd;
    int VTotal;
    int VDisp;
    int VBStart;
    int VSStart;
    int VSEnd;
    int VBEnd;

    int width;
    int height;
    int hpolarity;
    int vpolarity;
    int doublescan;
    int interlace;
    int interlaceadjust;

    long dotclockHz;
    long horzHz;
    long vert001Hz;
} CRTCPARAM;



typedef struct {
    DWORD denumerator;
    DWORD postscalar;
    DWORD divider;
    DWORD numerator;
    DWORD seqdivider;
    double dotclock;
    int x;
    int y;
    double horzKHz;
    double vertHz;
    int interlace;
    int hpolarity;
    int vpolarity;
    DWORD hskew;
} MiscParam;

typedef struct {
    int forx;
    int fory;
    CRTCPARAM *cp;
    DWORD group;
    DWORD orientation;
} SCRLIST;



void GetCrtcParam(CRTCPARAM *cp, MiscParam *mc, _Register *rg, int registerlen);
void SetGenericVGARegister(CRTCPARAM *cp);
long CalcDotclock(long Vert001Hz, int HTotal, int VTotal, int interlace);
long CalcVert001Hz(long dotclockHz, int HTotal, int VTotal, int interlace);
long CalcHorizontalHz(long dotclockHz, int HTotal);


void DispCrtcParam(CRTCPARAM *cp);

DWORD BitMov(DWORD dstdata, int dstbitpos, DWORD srcdata, int srcbitpos);

void _out(int edx, BYTE al);
BYTE _in(int edx);

void _outb(int edx, BYTE al);
BYTE _inb(int edx);
void _outw(int edx, WORD ax);
WORD _inw(int edx);
void _outl(int edx, DWORD eax);
DWORD _inl(int edx);




BYTE GetSeqReg(BYTE);
void SetSeqReg(BYTE, BYTE);
BYTE GetCrtcReg(BYTE);
void SetCrtcReg(BYTE, BYTE);
BYTE GetAtrbData(BYTE);
void SetAtrbData(BYTE, BYTE);
void SetGfxcReg(BYTE __idx, BYTE data);
BYTE GetGfxcReg(BYTE __idx);

void SetHVPolarity(int HPolar, int VPolar);
void SetTextHeight(int height);

void DisableGenerateSignal(void);
void EnableGenerateSignal(void);

int GetMode15KHz(CRTCPARAM *cp);

void DisableStretch(void);

void Centering(CRTCPARAM *cp, int dx, int dy);
void RegCRTCPARAM(CRTCPARAM *cp);
void GetCRTCPARAM(CRTCPARAM *cp);

int  GetSeqDivider(void);
void SetSeqDivider(int d0);

void SetCRTCPARAM_HSyncPos(CRTCPARAM *cp, int dx);
void SetCRTCPARAM_HSyncWidth(CRTCPARAM *cp,int dx);
void SetCRTCPARAM_VSyncPos(CRTCPARAM *cp, int dy);
void SetCRTCPARAM_VSyncWidth(CRTCPARAM *cp, int dy);
void SetCRTCPARAM_VSyncAdjust(CRTCPARAM *cp, int dx);
void SetCRTCPARAM_Apply(CRTCPARAM *cp);
