/*												*/
/*		scrlist.c								*/
/*			By	suzuki2go.						*/
/*												*/

#include "mode15k.h"

#define ALL 			-1



/*	PAL TEST  */

static CRTCPARAM mode768x576_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	 1048, 768, 768, 848, 928,1040,   312, 288, 288, 289, 297, 311,

// width height HPlr VPlr DblScn Intrlc Iratio
	 768,	576,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   16375000,  15625,   5000
};



static CRTCPARAM mode400x288_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  552, 400, 400, 456, 488, 544,   312, 288, 288, 289, 297, 311,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	288,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8611200,  15600,   5000
};



static CRTCPARAM mode384x288_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  536, 384, 384, 440, 472, 528,   312, 288, 288, 289, 297, 311,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	288,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8361600,  15600,   5000
};



static CRTCPARAM mode320x288_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  448, 320, 320, 368, 400, 440,   312, 288, 288, 289, 297, 311,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	288,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6988800,  15600,   5000
};



/*	For PC monitor	*/

static CRTCPARAM mode640x480_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  800, 640, 640, 672, 768, 792,   526, 480, 480, 481, 484, 525,

// width height HPlr VPlr DblScn Intrlc Iratio
	 640,	480,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   25248000,  31560,   6000
};



static CRTCPARAM mode320x240_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  400, 320, 320, 344, 368, 392,   526, 480, 480, 481, 484, 525,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   12624000,  31560,   6000
};



static CRTCPARAM mode400x300_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  528, 400, 400, 432, 480, 520,   632, 600, 600, 602, 610, 631,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	300,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   20021760,  37920,   6000
};



static CRTCPARAM mode800x600_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	 1056, 800, 800, 864, 960,1048,   632, 600, 600, 602, 610, 631,

// width height HPlr VPlr DblScn Intrlc Iratio
	 800,	600,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   40043520,  37920,   6000
};



static CRTCPARAM mode1024x768_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	 1280,1024,1024,1040,1128,1272,   800, 768, 768, 770, 780, 799,

// width height HPlr VPlr DblScn Intrlc Iratio
	1024,	768,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   61440000,  48000,   6000
};



static CRTCPARAM mode512x384_forpc = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  648, 512, 512, 520, 552, 640,   800, 768, 768, 770, 780, 799,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	384,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   31104000,  48000,   6000
};



/* Horizontal 31kHz */

static CRTCPARAM mode864x480_60_31 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1088, 864, 864, 904, 968,1080,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio 
     864,   480,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   34272000,  31500,   6000
};



static CRTCPARAM mode704x480_60_31 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      872, 704, 704, 736, 832, 864,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio 
     704,   480,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   27468000,  31500,   6000
};



static CRTCPARAM mode640x480_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  800, 640, 640, 672, 768, 792,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
	 640,	480,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   25200000,  31500,   6000
};



static CRTCPARAM mode512x480_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  640, 512, 512, 544, 584, 632,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	480,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   20160000,  31500,   6000
};



static CRTCPARAM mode512x384_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  648, 512, 512, 544, 584, 640,   525, 384, 384, 440, 442, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	384,   1,	0,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   20412000,  31500,   6000
};



static CRTCPARAM mode480x480_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  600, 480, 480, 512, 552, 592,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
	 480,	480,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   18900000,  31500,   6000
};



static CRTCPARAM mode456x480_55_31 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      568, 456, 456, 688, 760, 560,   573, 480, 480, 509, 511, 572,

// width height HPlr VPlr DblScn Intrlc Iratio 
     456,   480,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   17900520,  31515,   5500
};



static CRTCPARAM mode432x480_60_31 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      536, 432, 432, 712, 776, 528,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio 
     432,   480,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   16884000,  31500,   6000
};



static CRTCPARAM mode400x480_60_31 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      496, 400, 400, 720, 776, 488,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio 
     400,   480,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   15624000,  31500,   6000
};



static CRTCPARAM mode384x240_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  480, 384, 384, 408, 448, 472,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	240,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   15120000,  31500,   6000
};



static CRTCPARAM mode344x480_60_31 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      432, 344, 344, 728, 776, 424,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio 
     344,   480,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   13608000,  31500,   6000
};



static CRTCPARAM mode320x240_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  400, 320, 320, 344, 368, 392,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   12600000,  31500,   6000
};



static CRTCPARAM mode288x240_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  360, 288, 288, 312, 336, 352,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
	 288,	240,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   11340000,  31500,   6000
};



static CRTCPARAM mode256x240_60_31 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  320, 256, 256, 280, 304, 312,   525, 480, 480, 490, 492, 524,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	240,   1,	1,	   1,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10080000,  31500,   6000
};



/* Horizontal 24kHz */

static CRTCPARAM mode704x384_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      992, 704, 704, 824, 928, 984,   414, 384, 384, 388, 390, 413,

// width height HPlr VPlr DblScn Intrlc Iratio 
     704,   384,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   24641280,  24840,   6000
};



static CRTCPARAM mode512x400_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  720, 512, 512, 600, 680, 712,   432, 400, 400, 400, 402, 431,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	400,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   18006105,  25008,   5789
};



static CRTCPARAM mode512x384_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  712, 512, 512, 600, 640, 704,   414, 384, 384, 388, 390, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	384,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   17686080,  24840,   6000
};



static CRTCPARAM mode496x384_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  696, 496, 496, 584, 632, 688,   428, 384, 384, 395, 397, 427,

// width height HPlr VPlr DblScn Intrlc Iratio
	 496,	384,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   17277504,  24824,   5800
};



static CRTCPARAM mode456x384_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  648, 456, 456, 544, 584, 640,   452, 384, 384, 407, 410, 451,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	384,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   16109280,  24860,   5500
};



static CRTCPARAM mode432x384_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  608, 432, 432, 512, 552, 600,   414, 384, 384, 388, 390, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	384,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   15102720,  24840,   6000
};



static CRTCPARAM mode400x384_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  560, 400, 400, 472, 512, 552,   414, 384, 384, 388, 390, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	384,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   13910400,  24840,   6000
};



static CRTCPARAM mode344x384_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      480, 344, 344, 456, 512, 472,   414, 384, 384, 388, 390, 413,

// width height HPlr VPlr DblScn Intrlc Iratio 
     344,   384,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   11923200,  24840,   6000
};



/* Horizontal 15kHz */


static CRTCPARAM mode864x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1160, 864, 864, 936,1048,1152,   262, 240, 240, 241, 249, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     864,   480,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   18270000,  15750,   6000
};



static CRTCPARAM mode864x448_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1160, 864, 864, 936,1048,1152,   262, 224, 224, 233, 240, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     864,   448,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   18270000,  15750,   6000
};



static CRTCPARAM mode864x224_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1160, 864, 864, 936,1048,1152,   263, 224, 224, 234, 241, 262,

// width height HPlr VPlr DblScn Intrlc Iratio 
     864,   224,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   18304800,  15780,   6000
};



static CRTCPARAM mode704x512_58 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      920, 704, 704, 752, 824, 912,   272, 256, 256, 256, 263, 271,

// width height HPlr VPlr DblScn Intrlc Iratio 
     704,   512,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   14540600,  15805,   5800
};



static CRTCPARAM mode704x480_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      920, 704, 704, 752, 824, 912,   262, 240, 240, 241, 248, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     704,   480,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   14490000,  15750,   6000
};



static CRTCPARAM mode704x448_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      920, 704, 704, 752, 832, 912,   262, 224, 224, 233, 240, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     704,   448,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   14490000,  15750,   6000
};



static CRTCPARAM mode704x240_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      920, 704, 704, 752, 840, 912,   262, 240, 240, 241, 248, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     704,   240,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   14462400,  15720,   6000
};



static CRTCPARAM mode704x224_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      920, 704, 704, 752, 840, 912,   262, 224, 224, 233, 240, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     704,   224,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   14462400,  15720,   6000
};



static CRTCPARAM mode672x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  896, 672, 672, 728, 816, 888,   263, 240, 240, 241, 249, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 672,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   14138880,  15780,   6000
};



static CRTCPARAM mode640x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  848, 640, 640, 688, 776, 840,   262, 240, 240, 241, 248, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 640,	480,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   13356000,  15750,   6000
};



static CRTCPARAM mode640x448_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      848, 640, 640, 688, 776, 840,   262, 224, 224, 233, 240, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     640,   448,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   13356000,  15750,   6000
};



static CRTCPARAM mode640x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      848, 640, 640, 696, 768, 840,   262, 240, 240, 241, 249, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     640,   240,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   13330560,  15720,   6000
};



static CRTCPARAM mode640x224_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      848, 640, 640, 696, 768, 840,   262, 224, 224, 233, 240, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     640,   224,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   13330560,  15720,   6000
};



static CRTCPARAM mode512x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  680, 512, 512, 552, 624, 672,   262, 240, 240, 241, 248, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	480,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10710000,  15750,   6000
};



static CRTCPARAM mode512x448_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      680, 512, 512, 552, 624, 672,   262, 224, 224, 233, 240, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     512,   448,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   10710000,  15750,   6000
};



static CRTCPARAM mode512x256_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  680, 512, 512, 560, 608, 672,   277, 256, 256, 256, 263, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10736520,  15789,   5700
};



static CRTCPARAM mode512x256_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  688, 512, 512, 560, 616, 680,   287, 256, 256, 261, 269, 286,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10860080,  15785,   5500
};



static CRTCPARAM mode512x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  688, 512, 512, 560, 624, 680,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 512,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10856640,  15780,   6000
};



static CRTCPARAM mode512x224_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      688, 512, 512, 560, 624, 680,   263, 224, 224, 234, 242, 262,

// width height HPlr VPlr DblScn Intrlc Iratio 
     512,   224,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
   10856640,  15780,   6000
};



static CRTCPARAM mode480x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  640, 480, 480, 520, 584, 632,   262, 240, 240, 241, 248, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 480,	480,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10080000,  15750,   6000
};



static CRTCPARAM mode480x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  632, 480, 480, 504, 576, 624,   274, 256, 256, 255, 261, 273,

// width height HPlr VPlr DblScn Intrlc Iratio
	 480,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10390080,  16440,   6000
};



static CRTCPARAM mode456x480_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      608, 456, 456, 496, 552, 600,   262, 240, 240, 241, 248, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     456,   480,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    9576000,  15750,   6000
};



static CRTCPARAM mode456x480_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  608, 456, 456, 496, 552, 600,   286, 240, 240, 253, 261, 285,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	480,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9580560,  15757,   5500
};



static CRTCPARAM mode456x432_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  608, 456, 456, 496, 552, 600,   286, 216, 216, 241, 250, 285,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	432,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9580560,  15757,   5500
};



static CRTCPARAM mode456x256_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  608, 456, 456, 496, 552, 600,   287, 256, 256, 261, 267, 286,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9597280,  15785,   5500
};



static CRTCPARAM mode456x256_55_S = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  600, 456, 456, 480, 552, 592,   298, 256, 256, 265, 271, 297,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9834000,  16390,   5500
};



static CRTCPARAM mode456x240_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  616, 456, 456, 504, 560, 608,   277, 240, 240, 249, 256, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9726024,  15789,   5700
};



static CRTCPARAM mode456x240_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  608, 456, 456, 496, 552, 600,   286, 240, 240, 253, 261, 285,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9563840,  15730,   5500
};



static CRTCPARAM mode456x216_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  608, 456, 456, 496, 552, 600,   286, 216, 216, 241, 250, 285,

// width height HPlr VPlr DblScn Intrlc Iratio
	 456,	216,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9563840,  15730,   5500
};



static CRTCPARAM mode448x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  592, 448, 448, 488, 544, 584,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 448,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9341760,  15780,   6000
};



static CRTCPARAM mode432x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  576, 432, 432, 472, 528, 568,   262, 240, 240, 241, 248, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	480,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9072000,  15750,   6000
};



static CRTCPARAM mode432x448_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  576, 432, 432, 472, 528, 568,   262, 224, 224, 233, 240, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	448,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9072000,  15750,   6000
};



static CRTCPARAM mode432x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  568, 432, 432, 456, 520, 560,   274, 256, 256, 255, 263, 273,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9337920,  16440,   6000
};



static CRTCPARAM mode432x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  576, 432, 432, 472, 528, 568,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9089280,  15780,   6000
};



static CRTCPARAM mode432x240_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  576, 432, 432, 472, 520, 568,   272, 240, 240, 247, 255, 271,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9086976,  15776,   5800
};



static CRTCPARAM mode432x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  576, 432, 432, 472, 528, 568,   263, 224, 224, 234, 241, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 432,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	9089280,  15780,   6000
};



static CRTCPARAM mode400x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  536, 400, 400, 440, 488, 528,   262, 240, 240, 241, 248, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	480,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8442000,  15750,   6000
};



static CRTCPARAM mode400x448_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  536, 400, 400, 440, 488, 528,   262, 224, 224, 233, 240, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	448,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8442000,  15750,   6000
};



static CRTCPARAM mode400x432_532 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      536, 400, 400, 440, 480, 528,   296, 216, 216, 246, 254, 295,

// width height HPlr VPlr DblScn Intrlc Iratio 
     400,   432,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    8454756,  15773,   5320
};



static CRTCPARAM mode400x304_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  528, 400, 400, 424, 480, 520,   329, 304, 304, 304, 312, 328,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	304,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8685600,  16450,   5000
};



static CRTCPARAM mode400x288_54 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  528, 400, 400, 424, 480, 520,   305, 288, 288, 288, 296, 304,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	288,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8696160,  16470,   5400
};



static CRTCPARAM mode400x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  528, 400, 400, 424, 488, 520,   274, 256, 256, 255, 262, 273,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8680320,  16440,   6000
};



static CRTCPARAM mode400x256_538 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  536, 400, 400, 440, 488, 528,   293, 256, 256, 265, 267, 292,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8449182,  15763,   5380
};



static CRTCPARAM mode400x256_532 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  536, 400, 400, 440, 480, 528,   297, 256, 256, 266, 273, 296,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8469014,  15800,   5320
};



static CRTCPARAM mode400x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  536, 400, 400, 440, 496, 528,   263, 240, 240, 242, 249, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8458080,  15780,   6000
};



static CRTCPARAM mode400x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  536, 400, 400, 440, 496, 528,   263, 224, 224, 234, 241, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 400,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8458080,  15780,   6000
};



static CRTCPARAM mode400x216_532 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      536, 400, 400, 440, 480, 528,   297, 216, 216, 246, 254, 296,

// width height HPlr VPlr DblScn Intrlc Iratio 
     400,   216,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    8469014,  15800,   5320
};



static CRTCPARAM mode384x432_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  520, 384, 384, 424, 472, 512,   286, 216, 216, 241, 250, 285,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	432,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8193900,  15757,   5500
};



static CRTCPARAM mode384x280_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  504, 384, 384, 408, 464, 496,   326, 280, 280, 293, 300, 325,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	280,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8215200,  16300,   5000
};



static CRTCPARAM mode384x256_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      504, 384, 384, 408, 456, 496,   274, 256, 256, 256, 265, 273,

// width height HPlr VPlr DblScn Intrlc Iratio 
     384,   256,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    8285760,  16440,   6000
};



static CRTCPARAM mode384x256_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  520, 384, 384, 424, 472, 512,   287, 256, 256, 261, 269, 286,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8208200,  15785,   5500
};



static CRTCPARAM mode384x256_55_S = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  504, 384, 384, 408, 464, 496,   298, 256, 256, 267, 275, 297,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8260560,  16390,   5500
};



static CRTCPARAM mode384x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  512, 384, 384, 424, 472, 504,   262, 240, 240, 242, 250, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8048640,  15720,   6000
};



static CRTCPARAM mode384x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  512, 384, 384, 424, 472, 504,   262, 224, 224, 234, 242, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 384,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	8048640,  15720,   6000
};



static CRTCPARAM mode384x216_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      520, 384, 384, 424, 472, 512,   286, 216, 216, 241, 249, 285,

// width height HPlr VPlr DblScn Intrlc Iratio 
     384,   216,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    8179600,  15730,   5500
};



static CRTCPARAM mode376x240_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      504, 376, 376, 416, 464, 496,   262, 240, 240, 242, 250, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     376,   240,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    7922880,  15720,   6000
};



static CRTCPARAM mode368x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  496, 368, 368, 408, 456, 488,   262, 240, 240, 242, 250, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 368,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7797120,  15720,   6000
};



static CRTCPARAM mode360x256_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  472, 360, 360, 392, 448, 464,   277, 256, 256, 257, 265, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 360,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7452408,  15789,   5700
};



static CRTCPARAM mode360x240_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      472, 360, 360, 392, 432, 464,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio 
     360,   240,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    7448160,  15780,   6000
};



static CRTCPARAM mode352x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  472, 352, 352, 392, 432, 464,   262, 240, 240, 242, 250, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 352,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7419840,  15720,   6000
};



static CRTCPARAM mode344x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  456, 344, 344, 368, 424, 448,   273, 256, 256, 255, 261, 272,

// width height HPlr VPlr DblScn Intrlc Iratio
	 344,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7469280,  16380,   6000
};



static CRTCPARAM mode344x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  456, 344, 344, 376, 416, 448,   262, 240, 240, 242, 249, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 344,	480,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7182000,  15750,   6000
};



static CRTCPARAM mode344x448_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  456, 344, 344, 376, 416, 448,   262, 224, 224, 234, 241, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 344,	448,   1,	1,	   0,	  1,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7182000,  15750,   6000
};



static CRTCPARAM mode344x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  456, 344, 344, 376, 424, 448,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 344,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7195680,  15780,   6000
};



static CRTCPARAM mode344x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  456, 344, 344, 376, 416, 448,   263, 224, 224, 234, 241, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 344,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7195680,  15780,   6000
};



static CRTCPARAM mode336x448_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      448, 336, 336, 368, 408, 440,   262, 224, 224, 234, 241, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     336,   448,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    7056000,  15750,   6000
};



static CRTCPARAM mode336x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  448, 336, 336, 368, 416, 440,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 336,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	7069440,  15780,   6000
};



static CRTCPARAM mode336x224_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      448, 336, 336, 368, 416, 440,   262, 224, 224, 234, 241, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     336,   224,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    7042560,  15720,   6000
};



static CRTCPARAM mode320x448_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      424, 320, 320, 352, 384, 416,   262, 224, 224, 234, 241, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     320,   448,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    6678000,  15750,   6000
};



static CRTCPARAM mode320x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  424, 320, 320, 352, 392, 416,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6690720,  15780,   6000
};



static CRTCPARAM mode320x240_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  424, 320, 320, 352, 384, 416,   272, 240, 240, 246, 253, 271,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6689024,  15776,   5800
};



static CRTCPARAM mode320x240_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  424, 320, 320, 352, 384, 416,   277, 240, 240, 249, 257, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6694536,  15789,   5700
};



static CRTCPARAM mode320x240_56 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  424, 320, 320, 352, 384, 416,   282, 240, 240, 251, 258, 281,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6695808,  15792,   5600
};



static CRTCPARAM mode320x232_57 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      424, 320, 320, 352, 384, 416,   275, 232, 232, 244, 252, 274,

// width height HPlr VPlr DblScn Intrlc Iratio 
     320,   232,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    6684678,  15765,   5733
};



static CRTCPARAM mode320x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  424, 320, 320, 352, 392, 416,   263, 224, 224, 234, 241, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 320,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6690720,  15780,   6000
};



static CRTCPARAM mode304x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  408, 304, 304, 328, 376, 400,   274, 256, 256, 255, 263, 273,

// width height HPlr VPlr DblScn Intrlc Iratio
	 304,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6707520,  16440,   6000
};



static CRTCPARAM mode304x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  408, 304, 304, 336, 376, 400,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 304,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6438240,  15780,   6000
};



static CRTCPARAM mode304x240_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  408, 304, 304, 336, 376, 400,   278, 240, 240, 249, 258, 277,

// width height HPlr VPlr DblScn Intrlc Iratio
	 304,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6465168,  15846,   5700
};



static CRTCPARAM mode304x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  408, 304, 304, 336, 376, 400,   263, 224, 224, 234, 241, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 304,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6438240,  15780,   6000
};



static CRTCPARAM mode296x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  392, 296, 296, 328, 360, 384,   262, 240, 240, 242, 250, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 296,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6162240,  15720,   6000
};



static CRTCPARAM mode292x448_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      400, 296, 296, 328, 368, 392,   262, 224, 224, 234, 242, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     296,   448,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    6300000,  15750,   6000
};



static CRTCPARAM mode292x240_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      400, 296, 296, 328, 376, 392,   262, 240, 240, 242, 250, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     296,   240,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    6288000,  15720,   6000
};



static CRTCPARAM mode292x224_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      400, 296, 296, 328, 376, 392,   262, 224, 224, 234, 242, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     296,   224,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    6288000,  15720,   6000
};



static CRTCPARAM mode288x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  384, 288, 288, 320, 352, 376,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 288,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6059520,  15780,   6000
};



static CRTCPARAM mode288x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  384, 288, 288, 320, 352, 376,   262, 224, 224, 234, 242, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 288,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	6036480,  15720,   6000
};



static CRTCPARAM mode280x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  376, 280, 280, 312, 344, 368,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 280,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5933280,  15780,   6000
};



static CRTCPARAM mode272x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  360, 272, 272, 304, 328, 352,   262, 240, 240, 241, 249, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 272,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5659200,  15720,   6000
};



static CRTCPARAM mode272x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  360, 272, 272, 304, 328, 352,   262, 224, 224, 234, 241, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 272,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5659200,  15720,   6000
};



static CRTCPARAM mode264x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  352, 264, 264, 296, 320, 344,   262, 240, 240, 242, 250, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
	 264,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5533440,  15720,   6000
};



static CRTCPARAM mode256x480_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      336, 256, 256, 280, 312, 328,   261, 240, 240, 242, 249, 260,

// width height HPlr VPlr DblScn Intrlc Iratio 
     256,   480,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    5271840,  15690,   6000
};



static CRTCPARAM mode256x448_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      336, 256, 256, 280, 312, 328,   261, 224, 224, 233, 240, 260,

// width height HPlr VPlr DblScn Intrlc Iratio 
     256,   448,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    5271840,  15690,   6000
};



static CRTCPARAM mode256x432_55 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      344, 256, 256, 288, 312, 336,   286, 216, 216, 241, 249, 285,

// width height HPlr VPlr DblScn Intrlc Iratio 
     256,   432,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    5420580,  15757,   5500
};



static CRTCPARAM mode256x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 280, 320, 336,   274, 256, 256, 255, 263, 273,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5655360,  16440,   6000
};



static CRTCPARAM mode256x256_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 312, 336,   277, 256, 256, 257, 265, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5431416,  15789,   5700
};



static CRTCPARAM mode256x256_55 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 312, 336,   287, 256, 256, 262, 270, 286,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5430040,  15785,   5500
};



static CRTCPARAM mode256x256_55_S = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  336, 256, 256, 272, 312, 328,   299, 256, 256, 267, 275, 298,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5525520,  16445,   5500
};



static CRTCPARAM mode256x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 320, 336,   261, 240, 240, 242, 250, 260,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5387040,  15660,   6000
};



static CRTCPARAM mode256x240_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 312, 336,   271, 240, 240, 246, 254, 270,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5406992,  15718,   5800
};



static CRTCPARAM mode256x240_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 312, 336,   277, 240, 240, 248, 256, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5431416,  15789,   5700
};



static CRTCPARAM mode256x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 320, 336,   261, 224, 224, 233, 240, 260,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5387040,  15660,   6000
};



static CRTCPARAM mode256x224_606 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 320, 336,   260, 224, 224, 233, 240, 259,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5420958,  15758,   6061
};



static CRTCPARAM mode256x224_538 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  344, 256, 256, 288, 312, 336,   293, 224, 224, 249, 257, 292,

// width height HPlr VPlr DblScn Intrlc Iratio
	 256,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5422609,  15763,   5380
};



static CRTCPARAM mode256x216_55 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      344, 256, 256, 288, 312, 336,   286, 216, 216, 241, 249, 285,

// width height HPlr VPlr DblScn Intrlc Iratio 
     256,   216,   1,   1,     0,     0,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    5411120,  15730,   5500
};



static CRTCPARAM mode240x480_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      320, 240, 240, 264, 296, 312,   262, 240, 240, 242, 249, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     240,   480,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    5040000,  15750,   6000
};



static CRTCPARAM mode240x448_60 = { 
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      320, 240, 240, 264, 296, 312,   262, 224, 224, 234, 241, 261,

// width height HPlr VPlr DblScn Intrlc Iratio 
     240,   448,   1,   1,     0,     1,     0, 

// dotclkHz  horzHz  vertHz(in 0.01)
    5040000,  15750,   6000
};



static CRTCPARAM mode240x256_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  312, 240, 240, 264, 304, 304,   274, 256, 256, 255, 263, 273,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	5129280,  16440,   6000
};



static CRTCPARAM mode240x256_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  312, 240, 240, 264, 288, 304,   277, 256, 256, 257, 265, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	256,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	4926168,  15789,   5700
};



static CRTCPARAM mode240x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  312, 240, 240, 264, 288, 304,   263, 240, 240, 242, 249, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	4923360,  15780,   6000
};



static CRTCPARAM mode240x240_58 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  312, 240, 240, 264, 288, 304,   272, 240, 240, 246, 253, 271,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	4922112,  15776,   5800
};



static CRTCPARAM mode240x240_574 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  312, 240, 240, 264, 288, 304,   275, 240, 240, 248, 256, 274,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	4928352,  15796,   5744
};


static CRTCPARAM mode240x240_57 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  312, 240, 240, 264, 288, 304,   277, 240, 240, 249, 256, 276,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	240,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	4926168,  15789,   5700
};



static CRTCPARAM mode240x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
	  312, 240, 240, 264, 288, 304,   263, 224, 224, 234, 241, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
	 240,	224,   1,	1,	   0,	  0,	 0,

// dotclkHz  horzHz  vertHz(in 0.01)
	4923360,  15780,   6000
};




SCRLIST ScrModeList[] = {
	{ 864, 480, &mode864x480_60_31 , MODE31KHz    , SCREEN_HORZ | SCREEN_VERT },
	{ 864, 224, &mode864x480_60_31 , MODE31KHz    , SCREEN_HORZ | DUAL_MONITOR},	// for darius2
	{ 640, 480, &mode640x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 480, &mode512x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 384, &mode512x384_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 480, 480, &mode480x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 480, &mode456x480_55_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 480, &mode432x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 480, &mode400x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 240, &mode384x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 224, &mode384x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },	//
	{ 344, 480, &mode344x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 240, &mode320x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 224, &mode320x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },	//
	{ 288, 240, &mode288x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 288, 224, &mode288x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },	//
	{ 256, 240, &mode256x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 256, 224, &mode256x240_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },	//

	{ 512, 400, &mode512x400_58    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 384, &mode512x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 496, 384, &mode496x384_58    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 384, &mode456x384_55    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 384, &mode432x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 384, &mode400x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 384, &mode344x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },

	{ 864, 480, &mode864x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 864, 448, &mode864x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 864, 224, &mode864x448_60    , STRICTTV15KHz, SCREEN_HORZ | DUAL_MONITOR},	// for darius2
	{ 864, 224, &mode864x224_60    , STRICTTV15KHz, SCREEN_HORZ | DUAL_MONITOR},
	{ 704, 512, &mode704x512_58    , MODE15KHz    , SCREEN_HORZ | SCREEN_VERT },
	{ 672, 240, &mode672x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 640, 480, &mode640x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 640, 448, &mode640x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 640, 240, &mode640x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 640, 240, &mode640x448_60    , STRICTTV15KHz, SCREEN_HORZ | DUAL_MONITOR},	// for warriorb
	{ 640, 232, &mode640x448_60    , STRICTTV15KHz, SCREEN_HORZ | DUAL_MONITOR},	// for darius2d
	{ 640, 224, &mode640x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 512, 480, &mode512x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 448, &mode512x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 512, 256, &mode512x256_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 256, &mode512x256_55    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 240, &mode512x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 512, 240, &mode512x448_60    , STRICTTV15KHz, SCREEN_HORZ | DUAL_MONITOR},	// for nintendo-vs
	{ 512, 224, &mode512x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 480, 480, &mode480x480_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 480, 256, &mode480x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 480, &mode456x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 256, &mode456x256_55_S  , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 256, &mode456x256_55    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 240, &mode456x240_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 448, 240, &mode448x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 480, &mode432x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 448, &mode432x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 432, 256, &mode432x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 240, &mode432x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 240, &mode432x240_58    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 224, &mode432x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 400, 480, &mode400x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 448, &mode400x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 400, 304, &mode400x304_50    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 288, &mode400x288_54    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 256, &mode400x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 256, &mode400x256_538   , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 256, &mode400x256_532   , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 240, &mode400x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 224, &mode400x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 384, 280, &mode384x280_50    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 256, &mode384x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 256, &mode384x256_55_S  , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 256, &mode384x256_55    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 240, &mode384x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 384, 224, &mode384x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 376, 240, &mode376x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 368, 240, &mode368x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 360, 256, &mode360x256_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 360, 240, &mode360x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 352, 240, &mode352x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 480, &mode344x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 448, &mode344x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 344, 256, &mode344x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 240, &mode344x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 224, &mode344x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 336, 448, &mode336x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 336, 240, &mode336x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 336, 224, &mode336x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 320, 448, &mode320x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 320, 240, &mode320x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 240, &mode320x240_58    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 240, &mode320x240_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 240, &mode320x240_56    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 232, &mode320x232_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 320, 224, &mode320x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 304, 256, &mode304x256_60    , SPECIAL15KHz , SCREEN_HORZ | SCREEN_VERT },
	{ 304, 240, &mode304x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 304, 240, &mode304x240_57    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 304, 224, &mode304x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 296, 240, &mode296x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 292, 240, &mode292x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 292, 224, &mode292x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 288, 240, &mode288x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 288, 224, &mode288x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 280, 240, &mode280x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 272, 240, &mode272x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 272, 224, &mode272x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 264, 240, &mode264x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 264, 232, &mode264x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },	//
	{ 256, 480, &mode456x480_60    , STRICT15KHz  , SCREEN_HORZ | DUAL_MONITOR},	// for punchout
	{ 256, 448, &mode256x448_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 256, 256, &mode256x256_60    , SPECIAL15KHz , SCREEN_HORZ },
	{ 256, 256, &mode256x256_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 256, 256, &mode256x256_55_S  , SPECIAL15KHz , SCREEN_HORZ },
	{ 256, 256, &mode256x256_55    , MODE15KHz	  , SCREEN_HORZ },
	{ 256, 248, &mode256x256_60    , SPECIAL15KHz , SCREEN_HORZ },					//
	{ 256, 248, &mode256x256_57    , MODE15KHz	  , SCREEN_HORZ },					//
	{ 256, 240, &mode256x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 256, 240, &mode256x240_58    , MODE15KHz	  , SCREEN_HORZ },
	{ 256, 240, &mode256x240_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 256, 224, &mode256x224_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 256, 224, &mode256x224_606   , MODE15KHz	  , SCREEN_HORZ },
	{ 256, 224, &mode256x224_538   , MODE15KHz	  , SCREEN_HORZ },
	{ 248, 256, &mode256x256_57    , MODE15KHz	  , SCREEN_HORZ },					//
	{ 240, 256, &mode240x256_60    , SPECIAL15KHz , SCREEN_HORZ },
	{ 240, 256, &mode240x256_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 240, 248, &mode240x256_57    , MODE15KHz	  , SCREEN_HORZ },					//
	{ 240, 240, &mode240x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 240, 240, &mode240x240_58    , MODE15KHz	  , SCREEN_HORZ },
	{ 240, 240, &mode240x240_574   , MODE15KHz	  , SCREEN_HORZ },
	{ 240, 240, &mode240x240_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 240, 224, &mode240x224_60    , STRICTTV15KHz, SCREEN_HORZ },

	{ 400, 512, &mode704x512_58    , MODE15KHz	  , SCREEN_VERT },
	{ 480, 480, &mode864x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 480, 256, &mode480x256_60    , SPECIAL15KHz , SCREEN_VERT | DUAL_MONITOR },	// for punchout
	{ 256, 384, &mode456x384_55    , MODE24KHz	  , SCREEN_VERT },
	{ 240, 384, &mode432x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 224, 384, &mode400x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 224, 304, &mode400x304_50    , SPECIAL15KHz , SCREEN_VERT },
	{ 224, 288, &mode400x288_54    , SPECIAL15KHz , SCREEN_VERT },
	{ 256, 480, &mode512x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 256, 256, &mode456x256_55_S  , SPECIAL15KHz , SCREEN_VERT },
	{ 256, 256, &mode456x256_55    , MODE15KHz	  , SCREEN_VERT },
	{ 240, 256, &mode432x256_60    , SPECIAL15KHz , SCREEN_VERT },
	{ 224, 256, &mode400x256_60    , SPECIAL15KHz , SCREEN_VERT },
	{ 224, 256, &mode400x256_538   , MODE15KHz	  , SCREEN_VERT },
	{ 192, 256, &mode344x256_60    , SPECIAL15KHz , SCREEN_VERT },
	{ 256, 240, &mode456x240_57    , MODE15KHz	  , SCREEN_VERT },
	{ 240, 240, &mode432x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 240, 240, &mode432x240_58    , MODE15KHz	  , SCREEN_VERT },
	{ 224, 240, &mode400x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 192, 240, &mode344x240_60    , STRICT15KHz  , SCREEN_VERT },
	{	0,	 0, 			  0    , ALL		  , ALL }
};


SCRLIST AutoResolutionList[] = {
	{ 320, 288, &mode320x288_50    , PAL15KHz	  , ALL },
	{ 384, 288, &mode384x288_50    , PAL15KHz	  , ALL },
	{ 400, 288, &mode400x288_50    , PAL15KHz	  , ALL },
	{ 768, 576, &mode768x576_50    , PAL15KHz	  , ALL },

	{ 320, 240, &mode320x240_forpc , PCMONITOR	  , ALL },
	{ 400, 300, &mode400x300_forpc , PCMONITOR	  , ALL },
	{ 512, 384, &mode512x384_forpc , PCMONITOR	  , ALL },
	{ 640, 480, &mode640x480_forpc , PCMONITOR	  , ALL },
	{ 800, 600, &mode800x600_forpc , PCMONITOR	  , ALL },
	{1024, 768, &mode1024x768_forpc, PCMONITOR	  , ALL },

	{ 248, 240, &mode432x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 248, 256, &mode432x256_60    , SPECIAL15KHz , SCREEN_VERT },
	{ 224, 384, &mode400x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 240, 384, &mode432x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 256, 384, &mode456x384_55    , MODE24KHz	  , SCREEN_VERT },

	{ 240, ALL, &mode240x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 256, ALL, &mode256x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 264, ALL, &mode264x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 272, ALL, &mode272x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 280, ALL, &mode280x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 288, ALL, &mode288x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 296, ALL, &mode296x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 304, 240, &mode304x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 304, ALL, &mode304x256_60    , SPECIAL15KHz , SCREEN_HORZ },
	{ 320, ALL, &mode320x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 336, ALL, &mode336x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 352, ALL, &mode352x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 360, 240, &mode360x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 360, ALL, &mode360x256_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 368, ALL, &mode368x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 376, ALL, &mode376x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 384, 240, &mode384x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 384, ALL, &mode384x256_55_S  , SPECIAL15KHz , SCREEN_HORZ },
	{ 384, ALL, &mode384x256_55    , MODE15KHz	  , SCREEN_HORZ },
	{ 400, ALL, &mode400x256_532   , MODE15KHz	  , SCREEN_HORZ },
	{ 448, ALL, &mode448x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 512, 240, &mode512x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 512, 256, &mode512x256_57    , MODE15KHz	  , SCREEN_HORZ },
	{ 640, 240, &mode640x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 672, 240, &mode672x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 512, 384, &mode512x384_60_31 , MODE31KHz	  , SCREEN_HORZ },
	{ 512, 448, &mode512x448_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 512, 480, &mode512x480_60_31 , MODE31KHz	  , SCREEN_HORZ },
	{ 512, 480, &mode512x480_60    , STRICT15KHz  , SCREEN_HORZ },

	{ ALL, ALL, &mode640x480_forpc , PCMONITOR	  , ALL },
	{ ALL, ALL, &mode640x480_60_31 , MODE31KHz	  , ALL },
	{ ALL, ALL, &mode512x384_60    , MODE24KHz	  , ALL },
	{ ALL, ALL, &mode640x480_60    , STRICT15KHz  , ALL },
	{ ALL, ALL, &mode640x240_60    , STRICT15KHz  , ALL },
	{ ALL, ALL, &mode640x448_60    , STRICTTV15KHz, ALL },
	{ ALL, ALL, &mode640x224_60    , STRICTTV15KHz, ALL },
	{	0,	 0, 			  0    , ALL 		  , ALL }
};

SCRLIST YStretchList[] = {
	{ 704, 480, &mode704x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 480, &mode456x480_55_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 480, &mode432x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 480, &mode400x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 480, &mode344x480_60_31 , MODE31KHz	  , SCREEN_HORZ | SCREEN_VERT },

	{ 704, 384, &mode704x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 384, &mode456x384_55    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 384, &mode432x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 384, &mode400x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 384, &mode344x384_60    , MODE24KHz	  , SCREEN_HORZ | SCREEN_VERT },

	{ 704, 480, &mode704x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 704, 448, &mode704x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 704, 240, &mode704x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 704, 224, &mode704x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 456, 480, &mode456x480_55    , MODE15KHz    , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 432, &mode456x432_55    , TV15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 240, &mode456x240_55    , MODE15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 456, 216, &mode456x216_55    , TV15KHz	  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 480, &mode432x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 448, &mode432x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 432, 240, &mode432x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 432, 224, &mode432x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 400, 480, &mode400x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 448, &mode400x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 400, 240, &mode400x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 400, 224, &mode400x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 344, 480, &mode344x480_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 448, &mode344x448_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },
	{ 344, 240, &mode344x240_60    , STRICT15KHz  , SCREEN_HORZ | SCREEN_VERT },
	{ 344, 224, &mode344x224_60    , STRICTTV15KHz, SCREEN_HORZ | SCREEN_VERT },

	{ 512, 384, &mode512x480_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 512, 384, &mode512x448_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 512, 384, &mode512x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 512, 384, &mode512x224_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 400, 256, &mode400x432_532   , TV15KHz	  , SCREEN_HORZ },				// for mk		interlaced
	{ 400, 256, &mode400x216_532   , TV15KHz	  , SCREEN_HORZ },				// for mk
	{ 384, 256, &mode384x432_55    , TV15KHz	  , SCREEN_HORZ },				// for rtype	interlaced
	{ 384, 256, &mode384x216_55    , TV15KHz	  , SCREEN_HORZ },				// for rtype
	{ 336, 240, &mode336x448_60    , STRICTTV15KHz, SCREEN_HORZ },				// for gauntlet	interlaced
	{ 336, 240, &mode336x224_60    , STRICTTV15KHz, SCREEN_HORZ },				// for gauntlet
	{ 320, 240, &mode320x448_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 320, 240, &mode320x224_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 292, 240, &mode292x448_60    , STRICTTV15KHz, SCREEN_HORZ },				// for defender	interlaced
	{ 292, 240, &mode292x224_60    , STRICTTV15KHz, SCREEN_HORZ },				// for defender
	{ 256, 256, &mode256x432_55    , TV15KHz	  , SCREEN_HORZ },				// for vigilant	interlaced
	{ 256, 256, &mode256x216_55    , TV15KHz	  , SCREEN_HORZ },				// for vigilant
	{ 256, 240, &mode256x448_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 256, 240, &mode256x224_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 256, 192, &mode256x480_60    , STRICT15KHz  , SCREEN_HORZ },				// for omegaf interlaced
	{ 256, 192, &mode256x448_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 256, 192, &mode256x240_60    , STRICT15KHz  , SCREEN_HORZ },				// for omegaf
	{ 256, 192, &mode256x224_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 240, 192, &mode240x480_60    , STRICT15KHz  , SCREEN_HORZ },				// for mrdo interlaced
	{ 240, 192, &mode240x448_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 240, 192, &mode240x240_60    , STRICT15KHz  , SCREEN_HORZ },				// for mrdo
	{ 240, 192, &mode240x224_60    , STRICTTV15KHz, SCREEN_HORZ },

	{ 480, 512, &mode864x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 384, 512, &mode704x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 384, 512, &mode704x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 384, 512, &mode704x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 384, 512, &mode704x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 256, 384, &mode456x480_55    , MODE15KHz    , SCREEN_VERT },
	{ 256, 384, &mode456x432_55    , TV15KHz	  , SCREEN_VERT },
	{ 256, 384, &mode456x240_55    , MODE15KHz	  , SCREEN_VERT },
	{ 256, 384, &mode456x216_55    , TV15KHz	  , SCREEN_VERT },
	{ 256, 256, &mode456x480_55    , MODE15KHz    , SCREEN_VERT },
	{ 256, 256, &mode456x432_55    , TV15KHz	  , SCREEN_VERT },
	{ 256, 256, &mode456x240_55    , MODE15KHz	  , SCREEN_VERT },
	{ 256, 256, &mode456x216_55    , TV15KHz	  , SCREEN_VERT },
	{ 240, 320, &mode432x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 240, 320, &mode432x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 240, 320, &mode432x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 240, 320, &mode432x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 240, 288, &mode432x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 240, 288, &mode432x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 240, 288, &mode432x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 240, 288, &mode432x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 240, 256, &mode432x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 240, 256, &mode432x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 240, 256, &mode432x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 240, 256, &mode432x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 224, 320, &mode400x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 224, 320, &mode400x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 224, 320, &mode400x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 224, 320, &mode400x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 224, 288, &mode400x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 224, 288, &mode400x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 224, 288, &mode400x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 224, 288, &mode400x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 224, 256, &mode400x480_60    , STRICT15KHz  , SCREEN_VERT },					// for starforc interlaced
	{ 224, 256, &mode400x240_60    , STRICT15KHz  , SCREEN_VERT },					// for starforc non-interlaced
	{ 224, 256, &mode400x448_60    , STRICTTV15KHz, SCREEN_VERT },					// for starforc interlaced
	{ 224, 256, &mode400x224_60    , STRICTTV15KHz, SCREEN_VERT },					// for starforc non-interlaced
	{ 192, 256, &mode344x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 192, 256, &mode344x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 192, 256, &mode344x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 192, 256, &mode344x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{	0,	 0, 			  0    , ALL 		  , ALL }
};

SCRLIST YStretchAutoList[] = {
	{ 200, ALL, &mode344x480_60_31 , MODE31KHz	  , SCREEN_VERT },
	{ 200, ALL, &mode344x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 200, ALL, &mode344x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 200, ALL, &mode344x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 200, ALL, &mode344x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 200, ALL, &mode344x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 232, ALL, &mode400x480_60_31 , MODE31KHz	  , SCREEN_VERT },
	{ 232, ALL, &mode400x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 232, ALL, &mode400x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 232, ALL, &mode400x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 232, ALL, &mode400x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 232, ALL, &mode400x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 248, ALL, &mode432x480_60_31 , MODE31KHz	  , SCREEN_VERT },
	{ 248, ALL, &mode432x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 248, ALL, &mode432x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 248, ALL, &mode432x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 248, ALL, &mode432x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 248, ALL, &mode432x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 256, ALL, &mode456x480_55_31 , MODE31KHz	  , SCREEN_VERT },
	{ 256, ALL, &mode456x384_55    , MODE24KHz	  , SCREEN_VERT },
	{ 256, ALL, &mode456x480_55    , MODE15KHz	  , SCREEN_VERT },
	{ 256, ALL, &mode456x432_55    , TV15KHz	  , SCREEN_VERT },
	{ 256, ALL, &mode456x240_55    , MODE15KHz	  , SCREEN_VERT },
	{ 256, ALL, &mode456x216_55    , TV15KHz	  , SCREEN_VERT },
	{ 400, ALL, &mode704x480_60_31 , MODE31KHz	  , SCREEN_VERT },
	{ 400, ALL, &mode704x384_60    , MODE24KHz	  , SCREEN_VERT },
	{ 400, ALL, &mode704x480_60    , STRICT15KHz  , SCREEN_VERT },
	{ 400, ALL, &mode704x448_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 400, ALL, &mode704x240_60    , STRICT15KHz  , SCREEN_VERT },
	{ 400, ALL, &mode704x224_60    , STRICTTV15KHz, SCREEN_VERT },
	{ 480, ALL, &mode864x480_60    , STRICT15KHz  , SCREEN_VERT },

	{ 512, 400, &mode512x480_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 512, 400, &mode512x448_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 512, 400, &mode512x240_60    , STRICT15KHz  , SCREEN_HORZ },
	{ 512, 400, &mode512x224_60    , STRICTTV15KHz, SCREEN_HORZ },
	{ 400, 256, &mode400x432_532   , TV15KHz	  , SCREEN_HORZ },
	{ 400, 256, &mode400x216_532   , TV15KHz	  , SCREEN_HORZ },

	{ ALL, ALL, &mode640x480_forpc , PCMONITOR	  , ALL },
	{ ALL, ALL, &mode640x480_60_31 , MODE31KHz	  , ALL },
	{ ALL, ALL, &mode512x384_60    , MODE24KHz	  , ALL },
	{ ALL, ALL, &mode640x480_60    , STRICT15KHz  , ALL },
	{ ALL, ALL, &mode640x240_60    , STRICT15KHz  , ALL },
	{ ALL, ALL, &mode640x448_60    , STRICTTV15KHz, ALL },
	{ ALL, ALL, &mode640x224_60    , STRICTTV15KHz, ALL },
	{	0,	 0, 			  0    , ALL 		  , ALL }
};
