[BITS 32]

[SECTION .data]

[SECTION .text]


; ******************************************
; function prototype
; void do_emms(void);
; ******************************************

GLOBAL _do_emms

_do_emms:
    emms
    ret


; ******************************************
; function prototype
; INT16 lpf_apply_calc_asm(
;           LPF_SUB *ls,
;           INT32 p0s);
; ******************************************


; list of parameters
_ls             equ 8
_p0s            equ 12

; LPF_SUB struct
_ringbuff       equ 0
_ringbuff_top   equ 4
_h              equ 8
_taps           equ 12
_taps_mask      equ 16
_lpf_frac_bits  equ 20


GLOBAL _lpf_apply_calc_asm

_lpf_apply_calc_asm:
    push    ebp
    mov     ebp, esp
    sub     esp, 20
    mov     [ebp -  4], ebx
    mov     [ebp -  8], ecx
    mov     [ebp - 12], edx
    mov     [ebp - 16], esi
    mov     [ebp - 20], edi

    movd    mm7, [ebp + _p0s]
    pxor    mm2, mm2
    mov     edi, [ebp + _ls]
    pxor    mm3, mm3
    mov     eax, [edi + _taps]
    mov     ebx, [edi + _ringbuff]
    mov     ecx, [edi + _ringbuff_top]
    mov     edx, [edi + _h]
    mov     esi, [edi + _taps_mask]
    lea     eax, [edx + eax*2]          ; eax = edx end address

.loop1:
    movq    mm0, [edx]                  ; h[3] | h[2] | h[1] | h[0]
    and     ecx, esi                    ; mask ringbuff_index for wrap around
    paddd   mm7, mm2                    ; add result to mm7
    pmaddwd mm0, [ebx + ecx*2]          ; x[3]*h[3] + x[2]*h[2] | x[1]*h[1] + x[0]*h[0]
    add     ecx, BYTE 4                 ; ringbuff_index += 4
    movq    mm1, [edx + 8]              ; h[7] | h[6] | h[5] | h[4]
    and     ecx, esi                    ; mask ringbuff_index for wrap around
    paddd   mm7, mm3                    ; add result to mm7
    pmaddwd mm1, [ebx + ecx*2]          ; x[7]*h[7] + x[6]*h[6] | x[5]*h[5] + x[4]*h[4]
    add     ecx, BYTE 4                 ; ringbuff_index += 4

    movq    mm2, [edx + 16]             ; h[11] | h[10] | h[9] | h[8]
    and     ecx, esi                    ; mask ringbuff_index for wrap around
    paddd   mm7, mm0                    ; add result to mm7
    pmaddwd mm2, [ebx + ecx*2]          ; x[11]*h[11] + x[10]*h[10] | x[9]*h[9] + x[8]*h[8]
    add     ecx, BYTE 4                 ; ringbuff_index += 4
    movq    mm3, [edx + 24]             ; h[15] | h[14] | h[13] | h[12]
    add     edx, BYTE 32                ; h += 16;
    and     ecx, esi                    ; mask ringbuff_index for wrap around
    paddd   mm7, mm1                    ; add result to mm7
    pmaddwd mm3, [ebx + ecx*2]          ; x[15]*h[15] + x[14]*h[14] | x[13]*h[13] + x[12]*h[12]
    add     ecx, BYTE 4                 ; ringbuff_index += 4

    cmp     edx, eax
    jc      .loop1

    paddd   mm7, mm2                    ; add result to mm7
    movd    mm5, [edi + _lpf_frac_bits] ; mm5 = shift count
    paddd   mm7, mm3                    ; add result to mm7

    mov     edi, [ebp - 20]
    movq    mm6, mm7
    punpckhdq   mm7, mm7                ; mm7 = mm7 >> 32;
    mov     esi, [ebp - 16]
    paddd   mm7, mm6                    ; HI_DWORD + LOW_DWORD
    mov     edx, [ebp - 12]
    psrad   mm7, mm5                    ; Q14 format to INT32 (mm7 = mm7 >> 14)
    mov     ecx, [ebp -  8]
    packssdw    mm7, mm7                ; INT32 to INT16
    mov     ebx, [ebp -  4]
    movd    eax, mm7

    leave
;    emms
    ret
